Subject: Re: [net PATCH] fib_trie: Drop unnecessary calls to leaf_pull_suffix

From: David Ahern <[email-masked]>
Date: Mon, 27 Jul 2015 15:02:07 -0600

On 7/27/15 2:08 PM, Alexander Duyck wrote:
> It was reported that update_suffix was taking a long time on systems where
> a large number of leaves were attached to a single node.  As it turns out
> fib_table_flush was calling update_suffix for each leaf that didn't have all
> of the aliases stripped from it.  As a result, on this large node removing
> one leaf would result in us calling update_suffix for every other leaf on
> the node.
>
> The fix is to just remove the calls to leaf_pull_suffix since they are
> redundant as we already have a call in resize that will go through and
> update the suffix length for the node before we exit out of
> fib_table_flush or fib_table_flush_external.
>
> Reported-by: David Ahern<[email-masked]>
> Signed-off-by: Alexander Duyck<[email-masked]>
> ---
>
> This patch should apply to linux-4.1.y and newer kernels.
>
> I've done a bit of testing on my system and I no longer see update_suffix
> dominating the performance traces.  David if you can test with this patch
> to see if you still see the issue I would appreciate it.
>

Works for me. Thanks.

Tested-by: David Ahern <[email-masked]>